package tilingTypes.N3;

import tilingTypes.SymmetryType;
import tilingTypes.TilingType;

public class TilingTypeN3_29
   extends TilingType
{
   public TilingTypeN3_29(){
      super( "N3-29", 3, SymmetryType.p4 );

      paramMin = new int[]{};
      paramMax = new int[]{};
      paramDef = new int[]{};
      paramName = new String[]{ };

      // desc has: colour,   refcorner,corner2,   tile2Ix, tile2refcorner, tile2corner2,   mirrored
      description = new int[][]{
            {0, 0,0, 0,0,0, 0},
            {1, 2,1, 0,1,2, 0},
            {2, 1,0, 1,0,1, 0},
            {2, 2,1, 2,1,2, 0},
            {1, 1,0, 3,0,1, 0},
            {0, 2,1, 4,1,2, 0},

            {0, 0,2, 0,0,1, 0},
            {1, 2,1, 6,1,2, 0},
            {2, 1,0, 7,0,1, 0},
            {2, 2,1, 8,1,2, 0},
            {1, 1,0, 9,0,1, 0},
            {0, 2,1,10,1,2, 0},
      };
      info = "3a=b\nA=90\n(B+C=90)";
   }

   public void recalcBase(double[] paramValues) {
      double h = .4;

      baseTile.setPoint(0,  0,  0);
      baseTile.setPoint(1,h*3,  0);
      baseTile.setPoint(2,  0,  h);
   }
   public void recalcOffsets(double[] paramValues) {
      offsets[0] = tiles[0].getX(0)-tiles[5].getX(0);
      offsets[1] = tiles[0].getY(0)-tiles[5].getY(0);
      offsets[2] = tiles[5].getX(1)-tiles[6].getX(1);
      offsets[3] = tiles[5].getY(1)-tiles[6].getY(1);
   }
}
